﻿Option Strict On
Imports System.Windows.Threading
Imports Microsoft.Xna.Framework
Imports Microsoft.Xna.Framework.Audio
Imports System.IO

Partial Public Class MainPage
    Inherits PhoneApplicationPage

    Public Sub New()
        InitializeComponent()
    End Sub

    Dim myMicrophone As Microphone = Microphone.Default
    Dim myBuffer() As Byte
    Dim myStream As New MemoryStream
    Dim mySound As SoundEffectInstance
    Dim myState As Boolean = False

    Private Sub MainPage_Loaded(sender As Object, e As System.Windows.RoutedEventArgs) Handles MyBase.Loaded
        Dim myTimer As New DispatcherTimer()
        myTimer.Interval = TimeSpan.FromMilliseconds(50)

        AddHandler myTimer.Tick, Sub()
                                     FrameworkDispatcher.Update()

                                     If myState = True AndAlso mySound.State <> SoundState.Playing Then
                                         myState = False
                                         TextBlock1.Text = "[再生]または[記録]ボタンをクリック"
                                         recordButton.IsEnabled = True
                                         stopButton.IsEnabled = False
                                     End If

                                 End Sub

        myTimer.Start()
        AddHandler myMicrophone.BufferReady, Sub()
                                                 myMicrophone.GetData(myBuffer)
                                                 myStream.Write(myBuffer, 0, myBuffer.Length)
                                             End Sub
    End Sub

    Private Sub recordButton_Click(sender As System.Object, e As System.Windows.RoutedEventArgs) Handles recordButton.Click
        'myMicrophone.BufferDuration = TimeSpan.FromMilliseconds(500)
        myBuffer = New Byte(myMicrophone.GetSampleSizeInBytes(TimeSpan.FromMilliseconds(500)) - 1) {}
        myStream.SetLength(0)
        myMicrophone.Start()
        TextBlock1.Text = "録音中・・・・"
        stopButton.IsEnabled = True
    End Sub


    Private Sub stopButton_Click(sender As Object, e As System.Windows.RoutedEventArgs) Handles stopButton.Click
        If myMicrophone.State = MicrophoneState.Started Then
            myMicrophone.Stop()
        ElseIf mySound.State = SoundState.Playing Then
            mySound.Stop()
        End If
        TextBlock1.Text = "再生準備完了"
        playButton.IsEnabled = True
    End Sub


    Private Sub playButton_Click(sender As Object, e As System.Windows.RoutedEventArgs) Handles playButton.Click
        If myStream.Length > 0 Then
            TextBlock1.Text = "再生中・・・・"
            recordButton.IsEnabled = False
            stopButton.IsEnabled = True
            Dim sound As New SoundEffect(myStream.ToArray(), myMicrophone.SampleRate, AudioChannels.Mono)
            mySound = sound.CreateInstance
            myState = True
            mySound.Play()
        End If
    End Sub
End Class
